	
	BoxLibrary = function(el, itemtype)
	{
		this.borderthik = 1;
		this.bodycolor = "#BFD0E8";
		this.bordercolor = "#305383";
		this.off = false;
		this.Locpad = 6;
		this.mousePad = 0;
		this.el = el;
		this.itemtype = itemtype;
		this.grid = [];
		this.selected = [];
		this.attach();
	};
	BoxLibrary.prototype.attach = function()
	{
		var that = this;
		this.el.mousedown(function(e){ that._start(e); });
		this.el.scroll(function(e){ that.scr = {X: that.el.scrollLeft(), Y: that.el.scrollTop()} });
		this.cover = $jQ("<div></div>").css({position:"absolute", "background-color":"#FFF", top:0, left:0, opacity:0, display:"none"});
		this.cover.appendTo(this.el);
		this.scr = {X: this.el.scrollLeft(), Y: this.el.scrollTop()};
	};
	BoxLibrary.prototype.analize = function(e)
	{
		var that = this;
		try{ var ps = this.el.offset(); }
		catch(ex){ window.setTimeout(function(){ that.analize() }, 1000); return };
		this.scr = {X: this.el.scrollLeft(), Y: this.el.scrollTop()};
		this.ofTop = ps.top;
		this.ofLeft = ps.left;
		var items = this.el.find(this.itemtype);
		this.grid = [];
		this.selected = [];
		for(var i=0; i<items.length; i++)
		{
			var El = items.eq(i);
			var Loc = El.offset({scroll: false});
			var t = Loc.top+this.Locpad-this.ofTop+this.scr.Y;
			var r = Loc.left+El.width()-this.Locpad-this.ofLeft+this.scr.X;
			var b = Loc.top+El.height()-this.Locpad-this.ofTop+this.scr.Y;
			var l = Loc.left+this.Locpad-this.ofLeft+this.scr.X;
			this.grid.push({el: El, t: t, r: r, b: b, l: l});
		}
		this.items = items;
	};	
	BoxLibrary.prototype._start = function(E)
	{
		if(this.off)
			return;
		var that = this;
		if(!this.box)
		{
			var brdr = this.borderthik+"px solid "+this.bordercolor;
			this.box = $jQ("<div></div>").css({position: "absolute", opacity: 0.3, "background-color": this.bodycolor, border: brdr, "z-index": 99});
			this.box.appendTo(document.body);
			this.analize();
			var ps = this.el.offset();
			var W = this.el.width();
			var H = this.el.height();
			this.box.draggable({
				Limit: {X:[ps.left, ps.left+W], Y:[ps.top, ps.top+H]},			
				Snap : 5,
				onSnap: function(){ that._snap() }, 
				onDrag: function(){ that._onResize() }, 
				onComplete: function(){ that._end() }
			});
		}
		this.box.Drag.start(E);
	};
	BoxLibrary.prototype._snap = function(e)
	{
		if(this.onstart)
			this.onstart();
		var Ms = this.box.Drag.Mouse;
		var t = Ms.Start.Y;
		var l = Ms.Start.X;
		this.cover.css({height: "100%", width: "100%", visibility: "visible", display: "block"});
		this.box.css({display: "block", top: t, left: l, width: 0, height: 0 });
	};
	BoxLibrary.prototype._end = function()
	{
		if(this.onend)
			this.onend();
		this.cover.css("display", "none");
		this.box.css("display", "none");
	};
	BoxLibrary.prototype._onResize = function()
	{
		var Ms = this.box.Drag.Mouse;
		var Limit = this.box.Drag.Options.Limit;
		if(Ms.Now.X < Limit.X[0])
			Ms.Now.X = Limit.X[0];
		if(Ms.Now.X > Limit.X[1])
			Ms.Now.X = Limit.X[1];
		if(Ms.Now.Y < Limit.Y[0])
			Ms.Now.Y = Limit.Y[0];
		if(Ms.Now.Y > Limit.Y[1])
			Ms.Now.Y = Limit.Y[1];
		var w = Math.abs(Ms.Start.X - Ms.Now.X)-this.mousePad;
		var h = Math.abs(Ms.Start.Y - Ms.Now.Y)-this.mousePad;
		var t = Math.min(Ms.Start.Y, Ms.Now.Y)+this.mousePad;
		var l = Math.min(Ms.Start.X, Ms.Now.X)+this.mousePad;
		this.box.css({top: t, left: l, width: w, height: h});
		var wrange = {s: l-this.ofLeft+this.scr.X, e: l+w-this.ofLeft+this.scr.X};
		var hrange = {s: t-this.ofTop+this.scr.Y, e: t+h-this.ofTop+this.scr.Y};
		var current = [];
		for(i=0; i<this.grid.length; i++)
		{
			var el = this.grid[i];
			if((el.t > hrange.s && el.t < hrange.e) || (el.t <= hrange.s && el.b >= hrange.e) || (el.b > hrange.s && el.b < hrange.e))
				if((el.l > wrange.s && el.l < wrange.e) || (el.r > wrange.s && el.r < wrange.e) || (el.l <= wrange.s && el.r >= wrange.e) )
				{
					$jQ.arrayInclude(el.el, current);
					continue;
				}
			if((el.l > wrange.s && el.l < wrange.e) || (el.l <= wrange.s && el.r >= wrange.e) || (el.r > wrange.s && el.r < wrange.e))
				if((el.t > hrange.s && el.t < hrange.e) || (el.b > hrange.s && el.b < hrange.e) || (el.t <= hrange.s && el.b >= hrange.e) )
				{
					$jQ.arrayInclude(el.el, current);
					continue;
				}
		}
		for(var i=0; i<this.selected.length; i++)
			if($jQ.inArray(this.selected[i], current) == -1)
				this.deselect(this.selected[i]);
		for(i=0; i<current.length; i++)
			if($jQ.inArray(current[i], this.selected) == -1)
				this.select(current[i]);
		this.selected = current;
	};
	BoxLibrary.prototype.select = function(el)
	{
		if(this.onselect)
			this.onselect(el);
	};
	BoxLibrary.prototype.deselect = function(el)
	{
		if(this.ondeselect)
			this.ondeselect(el);
	};
